# generated by datamodel-codegen:
#   filename:  media_dcr_action.json

from __future__ import annotations

from enum import Enum
from typing import Any, Mapping, Optional, Sequence, Union

from pydantic import BaseModel, ConfigDict, Field, RootModel, conint


class ProvisionBaseAudiencePolicyIds(BaseModel):
    demographicsPolicyId: Optional[str] = None
    embeddingsPolicyId: Optional[str] = None
    matchingPolicyId: str
    segmentsPolicyId: Optional[str] = None


class MediaDcrAction1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    provisionBaseAudiencePolicyIds: ProvisionBaseAudiencePolicyIds


class MediaDcrAction2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    deprovisionBaseAudiencePolicyIds: Mapping[str, Any]


class ProvisionSeedAudiencePolicyIds(BaseModel):
    audiencesPolicyId: str


class MediaDcrAction3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    provisionSeedAudiencePolicyIds: ProvisionSeedAudiencePolicyIds


class MediaDcrAction4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    deprovisionSeedAudiencePolicyIds: Mapping[str, Any]


class DeleteCustomAudience(BaseModel):
    audienceId: str
    forceDeletePrerequisites: bool


class MediaDcrAction6(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    deleteCustomAudience: DeleteCustomAudience


class GetAudiencePrerequisites(BaseModel):
    audienceId: str


class MediaDcrAction7(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    getAudiencePrerequisites: GetAudiencePrerequisites


class Kind(Enum):
    BASE = 'BASE'


class AudienceReference19(BaseModel):
    kind: Kind


class Kind74(Enum):
    CUSTOM = 'CUSTOM'


class AudienceReference20(BaseModel):
    id: str
    kind: Kind74


class Kind75(Enum):
    SEED = 'SEED'


class AudienceReference21(BaseModel):
    audienceType: str
    kind: Kind75


class AudienceReference(
    RootModel[Union[AudienceReference19, AudienceReference20, AudienceReference21]]
):
    root: Union[AudienceReference19, AudienceReference20, AudienceReference21]


class BooleanOp(Enum):
    AND = 'AND'
    OR = 'OR'


class CombineOperator(Enum):
    INTERSECT = 'INTERSECT'
    UNION = 'UNION'
    DIFF = 'DIFF'


class Kind76(Enum):
    LOOKALIKE = 'LOOKALIKE'


class CustomAudienceDefinition13(BaseModel):
    excludeSeedAudience: Optional[bool] = None
    kind: Kind76
    reach: conint(ge=0)
    sourceRef: AudienceReference


class Kind77(Enum):
    RULE_BASED = 'RULE_BASED'


class FilterOperator(Enum):
    CONTAINS_ANY_OF = 'CONTAINS_ANY_OF'
    CONTAINS_NONE_OF = 'CONTAINS_NONE_OF'
    CONTAINS_ALL_OF = 'CONTAINS_ALL_OF'
    EMPTY = 'EMPTY'
    NOT_EMPTY = 'NOT_EMPTY'


class AudienceFilter(BaseModel):
    attribute: str
    operator: FilterOperator
    values: Optional[Sequence[str]] = None


class AudienceFilters(BaseModel):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class AudienceCombinator(BaseModel):
    filters: Optional[AudienceFilters] = None
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition14(BaseModel):
    combine: Optional[Sequence[AudienceCombinator]] = None
    filters: Optional[AudienceFilters] = None
    kind: Kind77
    sourceRef: AudienceReference


class CustomAudienceDefinition(
    RootModel[Union[CustomAudienceDefinition13, CustomAudienceDefinition14]]
):
    root: Union[CustomAudienceDefinition13, CustomAudienceDefinition14]


class CreateCustomAudience(BaseModel):
    definition: CustomAudienceDefinition
    name: str
    sharedWith: Sequence[str]


class MediaDcrAction5(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    createCustomAudience: CreateCustomAudience


class UpdateCustomAudience(BaseModel):
    audienceId: str
    definition: Optional[CustomAudienceDefinition] = None
    name: Optional[str] = None
    sharedWith: Optional[Sequence[str]] = None


class MediaDcrAction8(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    updateCustomAudience: UpdateCustomAudience


class MediaDcrAction(
    RootModel[
        Union[
            MediaDcrAction1,
            MediaDcrAction2,
            MediaDcrAction3,
            MediaDcrAction4,
            MediaDcrAction5,
            MediaDcrAction6,
            MediaDcrAction7,
            MediaDcrAction8,
        ]
    ]
):
    root: Union[
        MediaDcrAction1,
        MediaDcrAction2,
        MediaDcrAction3,
        MediaDcrAction4,
        MediaDcrAction5,
        MediaDcrAction6,
        MediaDcrAction7,
        MediaDcrAction8,
    ] = Field(..., title='MediaDcrAction')
